using System.Data;

using DevExpress.XtraPivotGrid;

namespace TestProject
{
    /// <summary>
    /// Ʈ 
    /// </summary>
    public static class ControlHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 
        /// </summary>
        public const string Employee = "Employee";

        /// <summary>
        /// 
        /// </summary>
        public const string Widget = "Widget";

        /// <summary>
        /// 
        /// </summary>
        public const string Month = "Month";

        /// <summary>
        /// ҸŰ
        /// </summary>
        public const string RetailPrice = "Retail Price";

        /// <summary>
        /// Ű
        /// </summary>
        public const string WholesalePrice = "Wholesale Price";

        /// <summary>
        /// 
        /// </summary>
        public const string Quantity = "Quantity";

        /// <summary>
        /// ܾ
        /// </summary>
        public const string Remains = "Remains";

        /// <summary>
        ///  A
        /// </summary>
        public const string EmployeeA = "Employee A";

        /// <summary>
        ///  B
        /// </summary>
        public const string EmployeeB = "Employee B";

        /// <summary>
        ///  A
        /// </summary>
        public const string WidgetA = "Widget A";

        /// <summary>
        ///  B
        /// </summary>
        public const string WidgetB = "Widget B";

        /// <summary>
        ///  C
        /// </summary>
        public const string WidgetC = "Widget C";

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region ʱȭϱ - Initialize(pivotGridControl)

        /// <summary>
        /// ʱȭϱ
        /// </summary>
        /// <param name="pivotGridControl">ǹ ׸ Ʈ</param>
        public static void Initialize(PivotGridControl pivotGridControl)
        {
            pivotGridControl.Fields.Add(Employee      , PivotArea.RowArea   );
            pivotGridControl.Fields.Add(Widget        , PivotArea.RowArea   );
            pivotGridControl.Fields.Add(Month         , PivotArea.ColumnArea);
            pivotGridControl.Fields.Add(RetailPrice   , PivotArea.DataArea  );
            pivotGridControl.Fields.Add(WholesalePrice, PivotArea.DataArea  );
            pivotGridControl.Fields.Add(Quantity      , PivotArea.DataArea  );
            pivotGridControl.Fields.Add(Remains       , PivotArea.DataArea  );

            foreach(PivotGridField field in pivotGridControl.Fields)
            {
                field.AllowedAreas = GetAllowedArea(field.Area);
            }

            pivotGridControl.OptionsView.RowTotalsLocation    = PivotRowTotalsLocation.Far;
            pivotGridControl.OptionsView.ColumnTotalsLocation = PivotTotalsLocation.Far;
            pivotGridControl.OptionsDataField.Area            = PivotDataArea.ColumnArea;
            pivotGridControl.OptionsDataField.AreaIndex       = 1;
        }

        #endregion
        #region  ̺ ϱ - GetDataTable()

        /// <summary>
        ///  ̺ ϱ
        /// </summary>
        /// <returns> ̺</returns>
        public static DataTable GetDataTable()
        {
            DataTable table = new DataTable();

            table.Columns.Add(Employee      , typeof(string));
            table.Columns.Add(Widget        , typeof(string));
            table.Columns.Add(Month         , typeof(int   ));
            table.Columns.Add(RetailPrice   , typeof(double));
            table.Columns.Add(WholesalePrice, typeof(double));
            table.Columns.Add(Quantity      , typeof(int   ));
            table.Columns.Add(Remains       , typeof(int   ));

            table.Rows.Add(EmployeeA, WidgetA, 6, 45.6, 40  , 3 , 0);
            table.Rows.Add(EmployeeA, WidgetA, 7, 38.9, 30  , 6 , 1);
            table.Rows.Add(EmployeeA, WidgetB, 6, 24.7, 20  , 7 , 0);
            table.Rows.Add(EmployeeA, WidgetB, 7, 8.3 , 7.5 , 5 , 1);
            table.Rows.Add(EmployeeA, WidgetC, 6, 10.0, 9   , 4 , 0);
            table.Rows.Add(EmployeeA, WidgetC, 7, 20.0, 18.5, 5 , 1);
            table.Rows.Add(EmployeeB, WidgetA, 6, 77.8, 70  , 2 , 0);
            table.Rows.Add(EmployeeB, WidgetA, 7, 32.5, 30  , 1 , 1);
            table.Rows.Add(EmployeeB, WidgetB, 6, 12  , 11  , 10, 0);
            table.Rows.Add(EmployeeB, WidgetB, 7, 6.7 , 5.5 , 4 , 1);
            table.Rows.Add(EmployeeB, WidgetC, 6, 30.0, 28.7, 6 , 0);
            table.Rows.Add(EmployeeB, WidgetC, 7, 40.0, 38.3, 7 , 1);

            return table;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region   ϱ - GetAllowedArea(area)

        /// <summary>
        ///   ϱ
        /// </summary>
        /// <param name="area"></param>
        /// <returns> </returns>
        private static PivotGridAllowedAreas GetAllowedArea(PivotArea area)
        {
            switch(area)
            {
                case PivotArea.ColumnArea : return PivotGridAllowedAreas.ColumnArea;
                case PivotArea.RowArea    : return PivotGridAllowedAreas.RowArea;
                case PivotArea.DataArea   : return PivotGridAllowedAreas.DataArea;
                case PivotArea.FilterArea : return PivotGridAllowedAreas.FilterArea;
                default                   : return PivotGridAllowedAreas.All;
            }
        }

        #endregion
    }
}