using System;
using System.Globalization;

using DevExpress.XtraEditors;
using DevExpress.XtraPivotGrid;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainForm()

        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            ControlHelper.Initialize(this.pivotGridControl);

            this.radioGroup.SelectedIndexChanged        += radioGroup_SelectedIndexChanged;
            this.pivotGridControl.CustomFieldValueCells += pivotGridControl_CustomFieldValueCells;
            this.pivotGridControl.FieldValueDisplayText += pivotGridControl_FieldValueDisplayText;

            this.pivotGridControl.DataSource = ControlHelper.GetDataTable();

            this.pivotGridControl.BestFit();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region  ׷  ε  óϱ - radioGroup_SelectedIndexChanged(sender, e)

        /// <summary>
        ///  ׷  ε  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void radioGroup_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.pivotGridControl.LayoutChanged();
        }

        #endregion
        #region ǹ ׸ Ʈ ʵ   Ŀ ϱ - pivotGridControl_CustomFieldValueCells(sender, e)

        /// <summary>
        /// ǹ ׸ Ʈ ʵ   Ŀ ϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void pivotGridControl_CustomFieldValueCells(object sender, PivotCustomFieldValueCellsEventArgs e)
        {
            PivotGridControl pivotGridControl = sender as PivotGridControl;

            if(pivotGridControl.DataSource == null)
            {
                return;
            }

            if(this.radioGroup.SelectedIndex != 1)
            {
                return;
            }

            FieldValueCell cell = e.FindCell
            (
                true,
                new Predicate<object[]>
                (
                    delegate(object[] valueArray)
                    {
                        foreach(object value in valueArray)
                        {
                            if(!object.Equals((decimal)0, value))
                            {
                                return false;
                            }
                        }
                        return true;
                    }
                )
            );

            if(cell != null)
            {
                e.Remove(cell);
            }
        }

        #endregion
        #region ǹ ׸ Ʈ ʱ  ÷ ؽƮ ϱ - pivotGridControl_FieldValueDisplayText(sender, e)

        /// <summary>
        /// ǹ ׸ Ʈ ʱ  ÷ ؽƮ ϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void pivotGridControl_FieldValueDisplayText(object sender, PivotFieldDisplayTextEventArgs e)
        {
            PivotGridControl pivotGridControl = sender as PivotGridControl;

            if(e.Field == pivotGridControl.Fields[ControlHelper.Month])
            {
                e.DisplayText = CultureInfo.CurrentCulture.DateTimeFormat.GetMonthName((int)e.Value);
            }
        }

        #endregion
    }
}